#include <stdio.h>
#include <netdb.h>
#include <string.h>
#include <stdlib.h>
#include <getopt.h>
#include <iptables.h>
#include <linux/netfilter_ipv4/ip_tables.h>
#include <linux/netfilter_ipv4/ip_nat_rule.h>

#if defined(IPTABLES_VERSION)
#define COMPATIBLE_VERSION IPTABLES_VERSION
#else
#define COMPATIBLE_VERSION NETFILTER_VERSION
#endif

static void
help(void) {
  printf("LOOPNAT v%s\n\n", COMPATIBLE_VERSION);
}

static void
init(struct ipt_entry_target *t, unsigned int *nfcache)
{
  *nfcache |= NFC_UNKNOWN;
}

static struct option opts [] = {
  {0}
};

static int
parse(int c, char **argv,
      int invert, unsigned int *flags,
      const struct ipt_entry *entry,
      struct ipt_entry_target **target)
{
  return 0;
}

static void final_check(unsigned int flags)
{
}

static void
print(const struct ipt_ip *ip,
      const struct ipt_entry_target *target,
      int numeric)
{
  printf(" ");
}

static void
save(const struct ipt_ip *ip,
     const struct ipt_entry_target *target)
{
}

static struct iptables_target loopnat = {
  NULL,
  "LOOPNAT",
  COMPATIBLE_VERSION,
  0,
  0,
  &help,
  &init,
  &parse,
  &final_check,
  &print,
  &save,
  opts
};

void _init(void)
{
  register_target(&loopnat);
}
